<template>
    <div id="app">
        <b-alert id="custom-alert"
                :show="dismissCountDown"
                dismissible
                :variant="status"
                @dismissed="dismissCountDown=0"
                @dismiss-count-down="countDownChanged"
        >
            {{message}}
        </b-alert>
        <router-view></router-view>
    </div>
</template>

<script>
import AlertService from './common/alert.service';
    export default {
        name: 'app',
        components: {},
        data() {
            return {
                dismissSecs: 5,
                dismissCountDown: 0,
                message: '',
                status: 'info'
            };
        },
        methods: {
            countDownChanged(dismissCountDown) {
                this.dismissCountDown = dismissCountDown
            },
            showAlert() {
                this.dismissCountDown = this.dismissSecs
            }
        },
        mounted() {
            AlertService.instance.listen().subscribe( data => {
                this.message = '';
                this.status = data.status;
                const {error, message} = data;
                if(error) {
                    for(let key in error.errors) {
                        this.message += key + ' ' +  error.errors[key][0]
                    }
                } else {
                    this.message = message || 'Done Successfully!';
                }
                this.showAlert();
            });
        },
        watch: {
            '$route' (to) {
                document.title = to.meta.title || 'Arvan Challenge'
            }
        },

    }
</script>

<style>

    #custom-alert{
        position: fixed;
        top: 60px;
        right: 10px;
        height:auto;
        width: auto;
        z-index: 99;
    }
</style>
